from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.lang import XComponent

@runtime_checkable
class XWindow(XComponent, Protocol):
    def setPosSize(self, X: int, Y: int, Width: int, Height: int, Flags: int) -> None: ...
    def getPosSize(self) -> Rectangle: ...
    def setVisible(self, Visible: bool) -> None: ...
    def setEnable(self, Enable: bool) -> None: ...
    def setFocus(self) -> None: ...
    def addWindowListener(self, xListener: XWindowListener) -> None: ...
    def removeWindowListener(self, xListener: XWindowListener) -> None: ...
    def addFocusListener(self, xListener: XFocusListener) -> None: ...
    def removeFocusListener(self, xListener: XFocusListener) -> None: ...
    def addKeyListener(self, xListener: XKeyListener) -> None: ...
    def removeKeyListener(self, xListener: XKeyListener) -> None: ...
    def addMouseListener(self, xListener: XMouseListener) -> None: ...
    def removeMouseListener(self, xListener: XMouseListener) -> None: ...
    def addMouseMotionListener(self, xListener: XMouseMotionListener) -> None: ...
    def removeMouseMotionListener(self, xListener: XMouseMotionListener) -> None: ...
    def addPaintListener(self, xListener: XPaintListener) -> None: ...
    def removePaintListener(self, xListener: XPaintListener) -> None: ...
